// The demonstration game for The Quill Adventure Writer by Zeljko Juric.
// This is, in fact, an illustrated (using drawn, vector-based pictures) and 
// slightly improved game developed in the tutorial from the Quill User Manual.

$$TITLE("The Jewel")

// +-----------------+
// | Aliases Section |
// +-----------------+

// Locations aliases

DEFINE(INTRO,0)
DEFINE(HALL,1)
DEFINE(KITCHEN,2)
DEFINE(DINING_ROOM,3)
DEFINE(LOUNGE,4)
DEFINE(BEDROOM,5)
DEFINE(CELLAR,6)

// Picture subroutines aliases

DEFINE(PAINTING,7)
DEFINE(FRYING_PAN,8)
DEFINE(FIRE_STONE,9)
DEFINE(BED_PILLAR,10)
DEFINE(DOOR,11)

// Objects aliases

DEFINE(LIT_TORCH,0)
DEFINE(UNLIT_TORCH,1)
DEFINE(APPLE,2)
DEFINE(KNIFE,3)
DEFINE(TV,4)
DEFINE(COAT,5)
DEFINE(HAT,6)
DEFINE(KEY,7)
DEFINE(CLOSED_SAFE,8)
DEFINE(JEWEL,9)
DEFINE(OPEN_SAFE,10)
DEFINE(STICK,11)

// Flags aliases

DEFINE(SAFE_HAS_BEEN_OPENED,11)
DEFINE(APPLE_EATEN,12)

$$VOCABULARY(4)

// +--------------------+
// | Vocabulary Section |
// +--------------------+

WORD(1,N)
WORD(1,NORTH)
WORD(2,S)
WORD(2,SOUTH)
WORD(3,E)
WORD(3,EAST)
WORD(4,W)
WORD(4,WEST)
WORD(5,NE)
WORD(6,NW)
WORD(7,SE)
WORD(8,SW)
WORD(9,U)
WORD(9,UP)
WORD(9,CLIMB)
WORD(9,ASCEND)
WORD(10,D)
WORD(10,DOWN)
WORD(10,DESCEND)
WORD(15,HALL)
WORD(16,KITCHEN)
WORD(17,DINING)
WORD(18,LOUNGE)
WORD(19,BEDROOM)
WORD(20,CELLAR)
WORD(30,TORCH)
WORD(31,APPLE)
WORD(32,KNIFE)
WORD(33,TELEVISION)
WORD(33,TV)
WORD(36,KEY)
WORD(37,SAFE)
WORD(38,JEWEL)
WORD(39,STICK)
WORD(40,UNLOCK)
WORD(40,OPEN)
WORD(41,CLOSE)
WORD(41,SHUT)
WORD(41,LOCK)
WORD(42,ON)
WORD(42,LIGHT)
WORD(43,OFF)
WORD(43,OUT)
WORD(43,UNLIGHT)
WORD(43,EXTINGUISH)
WORD(44,EAT)
WORD(50,BED)
WORD(100,GET)
WORD(100,TAKE)
WORD(101,DROP)
WORD(102,REMOVE)
WORD(103,WEAR)
WORD(104,I)
WORD(104,INVENTORY)
WORD(105,R)
WORD(105,REDESCRIBE)
WORD(106,QUIT)
WORD(106,STOP)
WORD(107,SAVE)
WORD(108,LOAD)
WORD(120,PICTURES)
WORD(121,TEXT)
WORD(121,WORDS)
WORD(122,ONCE)
WORD(122,NORMAL)
WORD(150,FLAGS)
WORD(151,OBJECTS)
WORD(152,SHOW)
WORD(153,MODIFY)

// Wearable objects...

WORD(200,COAT)
WORD(200,DEERSTALKER)
WORD(201,HAT)

$$LOCATIONS

// +-------------------+
// | Locations Section |
// +-------------------+

LOC($INTRO,"THE JEWEL\n\n"
    "In this very simple adventure, you need to find a valuable jewel which "
    "is hidden somewhere in the house.\n\n"
    "Don't take this game too seriously: this is only a tutorial coding "
    "example from the user manual of The Quill Adventure Writer for TI-89 & "
    "TI-92+...\n")
LOC($HALL,"I am in a Hall. The Kitchen is to the East, the Bedroom to "
    "the West and the Lounge to the South. Steps lead Down to the "
    "Cellar.")
LOC($KITCHEN,"I am in the Kitchen. The Hall is to the West and the Dining "
    "room is to the South.")
LOC($DINING_ROOM,"I am in the Dining Room. The Kitchen is to the North and "
    "the Lounge to the West.")
LOC($LOUNGE,"I am in the Lounge. To the North is the Hall while the "
    "Dining Room is to the East.")
LOC($BEDROOM,"I am in the Bedroom. The Hall is to the East and a bed "
    "is against the North wall.")
LOC($CELLAR,"I am in the Cellar. Steps lead Up to the Hall.")

$$MESSAGES

// +------------------+
// | Messages Section |
// +------------------+

MSG(0,"I'm hungry!")
MSG(1,"Ah. That's better!")
MSG(2,"I'm dying of starvation...")
MSG(3,"Well done. You've solved the Adventure.\n\n"
    "Ok, this was just an extremely simple game which is only a coding "
    "exercise from the tutorial for The Quill Adventure Writer. Now, why you "
    "don't try to code your (better) game by yourself?\n")
MSG(4,"Brrr. I don't want to go there. It's too cold!")

$$SYSTEM_MESSAGES

// +-------------------------+
// | System Messages Section |
// +-------------------------+

MSG(0,"Everything is dark. I can't see.")
MSG(1,"I can also see:")
MSG(2,"\nI await your command.")
MSG(3,"\nI'm ready for your instructions.")
MSG(4,"\nTell me what to do.")
MSG(5,"\nGive me your command.")
MSG(6,"Sorry, I don't understand that. Try some different words.")
MSG(7,"I can't go in that direction.")
MSG(8,"I can't.")
MSG(9,"I have with me:")
MSG(10," (worn)")
MSG(11,"Nothing at all.")
MSG(12,"Do you really want to quit now?")
MSG(13,"\nEND OF GAME\n\nDo you want to try again?")
MSG(14,"\nBye. Have a nice day.")
MSG(15,"OK.")
MSG(16,"Press any key to continue.")
MSG(17,"You have taken ")
MSG(18," turn")
MSG(19,"s")
MSG(20,".")
MSG(21,"You have scored ")
MSG(22,"%")
MSG(23,"I'm not wearing it.")
MSG(24,"I can't. My hands are full.")
MSG(25,"I already have it.")
MSG(26,"It's not here.")
MSG(27,"I can't carry any more.")
MSG(28,"I don't have it.")
MSG(29,"I'm already wearing it.")
MSG(30,"Y")
MSG(31,"N")

$$OBJECTS(1)                           // The player can carry only one object

// +-----------------+
// | Objects Section |
// +-----------------+

OBJ($LIT_TORCH,"A lit torch.",_,$NOWHERE)
OBJ($UNLIT_TORCH,"A torch.",TORCH,$KITCHEN)
OBJ($APPLE,"An apple.",APPLE,$DINING_ROOM)
OBJ($KNIFE,"A sharp knife.",KNIFE,$DINING_ROOM)
OBJ($TV,"A television.",_,$LOUNGE)
OBJ($COAT,"A coat.",COAT,$HALL)
OBJ($HAT,"A deerstalker hat.",HAT,$HALL)
OBJ($KEY,"A key.",KEY,$LOUNGE)
OBJ($CLOSED_SAFE,"A safe.",_,$CELLAR)
OBJ($JEWEL,"A jewel.",JEWEL,$NOWHERE)
OBJ($OPEN_SAFE,"An open safe.",_,$NOWHERE)
OBJ($STICK,"A walking stick.",STICK,$CARRIED)

$$CONNECTIONS

// +---------------------+
// | Connections Section |
// +---------------------+

FROM($HALL)
    CONN(E,$KITCHEN)
    CONN(W,$BEDROOM)
    CONN(S,$LOUNGE)
    CONN(D,$CELLAR)
    CONN(KITCHEN,$KITCHEN)
    CONN(BEDROOM,$BEDROOM)
    CONN(LOUNGE,$LOUNGE)
    CONN(CELLAR,$CELLAR)

FROM($KITCHEN)
    CONN(S,$DINING_ROOM)
    CONN(W,$HALL)
    CONN(DINING,$DINING_ROOM)
    CONN(HALL,$HALL)

FROM($DINING_ROOM)
    CONN(N,$KITCHEN)
    CONN(W,$LOUNGE)
    CONN(KITCHEN,$KITCHEN)
    CONN(LOUNGE,$LOUNGE)

FROM($LOUNGE)
    CONN(N,$HALL)
    CONN(E,$DINING_ROOM)
    CONN(HALL,$HALL)
    CONN(DINING,$DINING_ROOM)

FROM($BEDROOM)
    CONN(E,$HALL)
    CONN(HALL,$HALL)

FROM($CELLAR)
    CONN(U,$HALL)
    CONN(HALL,$HALL)
    
$$EVENTS

// +----------------+
// | Events Section |
// +----------------+

EVENT
    ISDESC                             // Description in progress?
    CLS                                // Clear screen
    SHOWLOC                            // Display the location
    NEWLINE
    LISTOBJ                            // List objects

EVENT
    AT($INTRO)                         // Intro screen?
    ANYKEY                             // Wait for a keypress...
    GOTO($HALL)                        // The game starts in the hall
    DESC                               // Describe the initial location...

EVENT
    AT($DINING_ROOM)                   // Dining room?
    CARRIED($JEWEL)                    // Jewel carried?
    CLS                                // Clear the screen
    PLUS($SCORE,50)                    // Final points
    MESSAGE(3)                         // Well done...
    SCORE
    TURNS
    END
    
EVENT
    EQ($TURNLO,6)                      // Six turns passed from the beginning
    ZERO($TURNHI)                      //   of the game?
    LET($CNT1,8)                       // Set "hunger" counter to 8 moves

EVENT
    NOTZERO($CNT1)                     // Hungry?
    ZERO($APPLE_EATEN)                 // Apple not eaten?
    MESSAGE(0)                         // I am hungry...

EVENT
    EQ($CNT1,1)                        // Counter equal to 1?
    ZERO($APPLE_EATEN)                 // Apple not eaten?
    MESSAGE(2)                         // I'm dying of starvation...
    PAUSE(100)                         // Wait a while...
    SCORE                              // Bad luck!
    TURNS
    END
    
$$ACTIONS

// +-----------------+
// | Actions Section |
// +-----------------+

// Movements with side effects...

ACTION(D,_)
    AT($HALL)                          // In the hall?
    SETVERB(CELLAR)                    // Memory saving trick!

ACTION(CELLAR,_)
    AT($HALL)                          // In the hall?
    NOTWORN($COAT)                     // Coat not worn?
    MESSAGE(4)                         // Sorry, too cold...
    DONE
  ELSE  
    AT($HALL)                          // In the hall?
    SET($DARK)                         // The cellar is dark...

ACTION(U,_)
    AT($CELLAR)                        // In the cellar?
    CLEAR($DARK)                       // No more darkness...

ACTION(HALL,_)      
    AT($CELLAR)                        // In the cellar?
    CLEAR($DARK)                       // No more darkness...

// Standard movements...

ACTION(_,_)
    TRYMOVE                            // Try to perform standard movements
    DESC                               //   through the Connections Section

// Some very common entries...

ACTION(GET,I)
    INVEN

ACTION(I,_)
    INVEN

ACTION(R,_)
    REDRAW
    DESC

ACTION(QUIT,_)
    QUIT
    SCORE
    TURNS
    END

ACTION(SAVE,_)
    SAVE

ACTION(LOAD,_)
    LOAD

// Getting, dropping, wearing and removing...

ACTION(GET,TORCH)
    PRESENT($LIT_TORCH)                // Lit torch present?
    GET($LIT_TORCH)                    // Well, get it...
    OK

ACTION(GET,_)
    AUTOG                              // Automatic getting...
    OK

ACTION(DROP,TORCH)
    PRESENT($LIT_TORCH)                // Lit torch present?
    DROP($LIT_TORCH)                   // Well, drop it...
    OK
        
ACTION(DROP,_)
    AUTOD                              // Automatic dropping...
    OK    
    
ACTION(WEAR,_)
    AUTOW                              // Automatic wearing...
    OK

ACTION(REMOVE,_)
    AUTOR                              // Automatic removing...
    OK

// Turning the torch on or off...

ACTION(ON,TORCH)
    SETVERB(TORCH)                     // Turn phrase ON TORCH to TORCH ON...
    SETNOUN(ON)
    CANCEL

ACTION(TORCH,ON)
    PRESENT($UNLIT_TORCH)              // Unlit torch is present?
    ZERO($SCORE)                       // No score yet?
    LET($SCORE,25)                     // First points (continue scanning)...
  CONTINUE
    PRESENT($UNLIT_TORCH)              // Unlit torch is present?
    SWAP($LIT_TORCH,$UNLIT_TORCH)      // Make it lit...
    OK

ACTION(OFF,TORCH)
    PRESENT($LIT_TORCH)                // Lit torch is present?
    SWAP($LIT_TORCH,$UNLIT_TORCH)      // Make it unlit...
    OK

ACTION(TORCH,OFF)
    PRESENT($LIT_TORCH)                // Lit torch is present?
    SWAP($LIT_TORCH,$UNLIT_TORCH)      // Make it unlit...
    OK
    
ACTION(OPEN,SAFE)
    PRESENT($CLOSED_SAFE)              // Closed safe is present?
    CARRIED($KEY)                      // Key carried?
    PRESENT($LIT_TORCH)                // Lit torch is present?
    ZERO($SAFE_HAS_BEEN_OPENED)        // Safe has not been opened before?
    SWAP($CLOSED_SAFE,$OPEN_SAFE)      // Well, open it...
    LET($SCORE,50)                     // Set score to 50%
    CREATE($JEWEL)                     // Make the jewel to be available
    SET($SAFE_HAS_BEEN_OPENED)         // Signal that the safe has been opened
    DESC                               // Redescribe location
  ELSE
    PRESENT($CLOSED_SAFE)              // Otherwise: Closed safe present, key
    CARRIED($KEY)                      //   carried, lit torch present (but
    PRESENT($LIT_TORCH)                //   the safe has been opened before)?
    SWAP($CLOSED_SAFE,$OPEN_SAFE)      // Just open the safe
    OK
    
ACTION(CLOSE,SAFE)
    PRESENT($OPEN_SAFE)                // Open safe is present?
    PRESENT($LIT_TORCH)                // Lit torch is present?
    SWAP($OPEN_SAFE,$CLOSED_SAFE)      // Close the safe
    OK

ACTION(EAT,APPLE)
    PRESENT($APPLE)                    // An apple is present?
    SET($APPLE_EATEN)                  // Well, mark it as eaten
    NOTZERO($CNT1)                     // Hungry?
    DESTROY($APPLE)                    // Destroy the apple
    MESSAGE(1)                         // Much better...
    DONE
  ELSE
    PRESENT($APPLE)                    // An apple is present?
    DESTROY($APPLE)                    // Destroy the apple
    OK

// Actions for turning pictures on or off...

ACTION(TEXT,_)
    PICOFF
    OK

ACTION(PICTURES,OFF)
    PICOFF
    OK

ACTION(PICTURES,ONCE)
    PICNORM
    OK

ACTION(PICTURES,_)
    PICON
    DESC
            
// Debugging commands...

ACTION(FLAGS,_)                        // Type FLAGS or SHOW FLAGS to
    EXTERN(0)                          //   display values of all flags

ACTION(SHOW,FLAGS)
    EXTERN(0)

ACTION(OBJECTS,_)                      // Type OBJECTS or SHOW OBJECTS to
    EXTERN(1)                          //   display locations of all objects

ACTION(SHOW,OBJECTS)
    EXTERN(1)

ACTION(MODIFY,FLAGS)                   // Type MODIFY FLAGS to modify a flag;
    EXTERN(2)                          //   you will be asked for a flag_no 
                                       //   and a value...
ACTION(MODIFY,OBJECTS)
    EXTERN(3)                          // Type MODIFY OBJECTS to modify an 
                                       //   object location; you will be asked 
$$PICTURES                             //   for a obj_no and a loc_no

// +------------------+
// | Pictures Section |
// +------------------+

// These pictures are extracted from the demo which comes with The Illustrator
// extension package for The Quill for the ZX Spectrum by Gilsoft Ltd. These
// pictures are first converted using SNA2QUIL converter, then improved and
// corrected manually to fix some details which are not converted correctly,
// or which are discarded, like information about coloring etc.

DRAWING($HALL,$FULLSCR)
    LINE(55,-71)
    LINE(145,0)
    LINE(55,71)
    MOVE(0,-175)
    LINE(-55,23)
    LINE(-145,0)
    LINE(-55,-23)
    MOVE(200,23)
    LINE(0,81)
    LINE(-145,0)
    LINE(0,-81)
    MOVE(-40,133)
    LINE(0,-112)
    LINE(24,3)
    LINE(0,78)
    LINE(-8,0)
    LINE(0,-79)
    MOVE(112,58)
    CALL(4,$DOOR)
    PLOT(72,167)
    LINE(32,-47)
    LINE(47,0)
    LINE(32,47)
    LINE(-111,0)
    MOVE(2,0)
    LINE(8,-8)
    LINE(91,0)
    LINE(8,8)
    MOVE(-16,-8)
    LINE(-6,-6)
    LINE(-62,0)
    LINE(-6,6)
    MOVE(14,-6)
    LINE(4,-4)
    LINE(38,0)
    LINE(4,4)
    MOVE(-8,-4)
    LINE(-3,-3)
    LINE(-24,0)
    LINE(-3,3)
    AMOVE(72,79)
    CALL(0,$PAINTING)
    MOVE(-83,55)
    LINE(-16,21)
    PLOT(0,175)
    FILL(128,-32)
    SHADE(248,-40,$HATCHFILL)
    SHADE(48,-80,$HATCHFILL)
    SHADE(32,0,$INTERLEAVEFILL)
    SHADE(32,-168,$INTERLEAVEFILL)
    SHADE(80,-80,$SQDOTFILL)
    SHADE(24,-120,$DOTFILL)
    SHADE(36,-120,$VINTERLEAVEFILL)    
    FILL(24,-35)
END_DRAWING

DRAWING($KITCHEN,$FULLSCR)
    MOVE(120,-55)
    LINE(0,-48)
    LINE(135,0)
    MOVE(0,48)
    LINE(-135,0)
    LINE(-64,17)
    PLOT(56,140)
    LINE(0,-52)
    LINE(-14,-14)
    LINE(-11,-2)
    LINE(0,-40)
    LINE(-16,0)
    LINE(0,42)
    LINE(6,2)
    LINE(7,0)
    LINE(3,-4)
    MOVE(-16,2)
    LINE(-12,3)
    LINE(8,2)
    LINE(12,10)
    LINE(0,63)
    LINE(33,-12)
    MOVE(-5,-5)
    LINE(-21,8)
    LINE(0,-23)
    LINE(18,-4)
    LINE(0,20)
    PLOT(49,108)
    LINE(-19,5)
    LINE(0,-16)
    LINE(17,-3)
    LINE(0,15)
    MOVE(-24,43)
    LINE(-23,-6)
    PLOT(3,77)
    LINE(-3,0)
    MOVE(49,4)
    LINE(71,-9)
    MOVE(-4,-2)
    LINE(-72,6)
    MOVE(71,-6)
    LINE(140,0)
    MOVE(-144,0)
    LINE(0,-46)
    LINE(144,0)
    LINE(0,-3)
    LINE(-138,0)
    LINE(-117,-15)
    LINE(0,8)
    LINE(111,10)
    MOVE(3,-3)
    LINE(0,-21)
    AMOVE(114,67)
    CALL(2,$FRYING_PAN)
    MOVE(14,32)
    CALL(2,$FRYING_PAN)
    MOVE(13,35)
    CALL(2,$FRYING_PAN)
    MOVE(15,27)
    CALL(2,$FRYING_PAN)
    MOVE(15,39)
    CALL(2,$FRYING_PAN)
    MOVE(13,16)
    CALL(1,$FRYING_PAN)
    MOVE(-5,40)
    CALL(1,$FRYING_PAN)
    MOVE(12,-2)
    CALL(1,$FRYING_PAN)
    MOVE(-2,40)
    CALL(1,$FRYING_PAN)
    MOVE(5,14)
    CALL(2,$FRYING_PAN)
    PLOT(114,0)
    SHADE(72,104,$DOTFILL)
    SHADE(8,8,$DOTFILL)
    PLOT(24,142)
    SHADE(82,-136,$BRICKFILL)
    SHADE(40,-40,$BRICKFILL)
    FILL(1,0)
    MOVE(-5,-56)
    SHADE(-4,4,$HATCHFILL)
    SHADE(0,-16,$HATCHFILL)
    SHADE(24,24,$CLOSEDOTFILL)
    SHADE(16,16,$CLOSEDOTFILL)
    SHADE(24,40,$VLINEFILL)
    FILL(32,-8)
    FILL(112,-15)
    FILL(72,-66)
    MOVE(103,-38)
    LINE(3,3)
    FILL(-2,2)
    SHADE(12,0,$CLOSEDOTFILL)
    SHADE(-8,0,$CLOSEDOTFILL)
    FILL(31,0)
    SHADE(52,0,$CLOSEDOTFILL)
    SHADE(73,0,$HATCHFILL)
    SHADE(115,0,$HATCHFILL)
    PLOT(165,71)
    LINE(0,49)
    MOVE(45,0)
    LINE(0,-48)
    MOVE(0,-51)
    LINE(0,-21)
    MOVE(-45,21)
    LINE(0,-21)
    SHADE(0,170,$INTERLEAVEFILL)
    SHADE(-20,35,$LIGHTDOTFILL)
    SHADE(-160,35,$LIGHTDOTFILL)
END_DRAWING

DRAWING($DINING_ROOM,$FULLSCR)
    PLOT(56,119)
    LINE(144,0)
    LINE(-48,-32)
    LINE(-48,0)
    LINE(-48,32)
    LINE(0,43)
    LINE(7,0)
    LINE(0,-16)
    MOVE(0,16)
    LINE(8,3)
    LINE(8,-2)
    LINE(0,-16)
    MOVE(0,16)
    LINE(6,2)
    LINE(13,-2)
    LINE(5,2)
    LINE(16,-3)
    LINE(0,-4)
    MOVE(0,4)
    LINE(15,3)
    LINE(4,-2)
    LINE(11,3)
    LINE(8,-2)
    LINE(12,2)
    LINE(13,-3)
    LINE(0,-16)
    MOVE(0,16)
    LINE(3,3)
    LINE(7,-2)
    LINE(8,3)
    LINE(0,-48)
    MOVE(-3,47)
    LINE(0,9)
    LINE(-5,0)
    LINE(0,-11)
    MOVE(-133,-3)
    LINE(0,14)
    LINE(4,0)
    LINE(0,-13)
    PLOT(102,88)
    LINE(0,-9)
    LINE(-44,4)
    LINE(0,34)
    MOVE(2,-34)
    LINE(1,4)
    LINE(0,28)
    MOVE(11,-33)
    LINE(1,3)
    LINE(0,22)
    MOVE(6,-4)
    LINE(0,-18)
    LINE(-1,-4)
    MOVE(-2,0)
    LINE(0,25)
    MOVE(12,-25)
    LINE(1,3)
    LINE(0,13)
    MOVE(4,-17)
    LINE(0,14)
    MOVE(1,-1)
    LINE(0,-13)
    MOVE(-1,0)
    INV_LINE(-7,0)
    MOVE(-9,1)
    INV_LINE(-4,1)
    PLOT(152,79)
    LINE(45,4)
    LINE(0,33)
    MOVE(-2,-1)
    LINE(0,-32)
    MOVE(-14,-1)
    LINE(0,24)
    MOVE(-3,-1)
    LINE(0,-24)
    LINE(-2,2)
    LINE(0,20)
    MOVE(-9,-6)
    LINE(0,-17)
    MOVE(-3,0)
    LINE(0,15)
    MOVE(-1,-1)
    LINE(0,-14)
    MOVE(-9,-2)
    LINE(0,10)
    MOVE(-1,-9)
    INV_LINE(-2,0)
    INV_LINE(3,0)
    MOVE(10,1)
    INV_LINE(3,0)
    MOVE(11,1)
    INV_LINE(3,0)
    MOVE(-13,0)
    LINE(0,-65)
    LINE(87,-16)
    MOVE(-254,0)
    LINE(86,15)
    LINE(0,66)
    MOVE(0,-66)
    LINE(83,0)
    MOVE(30,115)
    LINE(55,34)
    PLOT(0,164)
    LINE(56,-32)
    PLOT(86,81)
    SHADE(0,2,$CLOSEDOTFILL)
    SHADE(-18,18,$CLOSEDOTFILL)
    SHADE(12,0,$CLOSEDOTFILL)
    SHADE(72,0,$CLOSEDOTFILL)
    SHADE(88,16,$CLOSEDOTFILL)
    SHADE(104,8,$CLOSEDOTFILL)
    SHADE(-56,80,$INTERLEAVEFILL)
    SHADE(0,88,$INTERLEAVEFILL)
    SHADE(136,86,$INTERLEAVEFILL)
    MOVE(-79,1)
    LINE(0,-39)
    LINE(31,2)
    LINE(-1,31)
    LINE(-28,10)
    PLOT(2,86)
    LINE(0,-43)
    LINE(5,-5)
    LINE(35,2)
    LINE(2,2)
    LINE(0,32)
    LINE(-2,4)
    LINE(-31,14)
    LINE(-9,-6)
    PLOT(8,78)
    LINE(5,-5)
    LINE(4,0)
    LINE(2,-2)
    LINE(-5,-5)
    LINE(0,-6)
    LINE(6,-4)
    LINE(6,0)
    LINE(6,6)
    LINE(0,7)
    LINE(5,6)
    PLOT(9,77)
    SHADE(2,2,$HATCHFILL)
    SHADE(88,0,$SQDOTFILL)
    SHADE(72,-72,$DOTFILL)
    SHADE(40,0,$LIGHTDOTFILL)
    SHADE(200,0,$LIGHTDOTFILL)
    SHADE(5,-24,$CIRCLEFILL)
END_DRAWING

DRAWING($LOUNGE,$FULLSCR)
    PLOT(120,0)
    LINE(0,119)
    LINE(48,0)
    LINE(0,-7)
    LINE(-5,-5)
    LINE(0,-8)
    LINE(5,-5)
    LINE(18,-5)
    LINE(1,-9)
    LINE(-6,-12)
    LINE(0,-13)
    LINE(10,-7)
    LINE(48,0)
    LINE(-8,80)
    LINE(-25,9)
    LINE(-38,-10)
    LINE(0,-8)
    MOVE(62,-71)
    LINE(-8,10)
    LINE(-1,14)
    LINE(5,10)
    LINE(-2,14)
    LINE(-16,4)
    LINE(-5,5)
    LINE(0,10)
    LINE(4,5)
    MOVE(1,-20)
    LINE(4,8)
    LINE(0,7)
    LINE(-4,4)
    LINE(16,-5)
    LINE(-17,6)
    LINE(0,16)
    MOVE(-38,-42)
    LINE(5,6)
    LINE(0,12)
    LINE(33,8)
    MOVE(-33,-8)
    LINE(17,-7)
    LINE(0,-56)
    MOVE(0,55)
    LINE(11,2)
    MOVE(-29,22)
    LINE(0,8)
    LINE(-5,0)
    LINE(0,-9)
    MOVE(42,9)
    LINE(0,10)
    LINE(-2,1)
    LINE(-4,-1)
    LINE(0,-10)
    MOVE(27,-1)
    LINE(0,-7)
    MOVE(-4,1)
    LINE(0,6)
    LINE(4,0)
    PLOT(7,175)
    LINE(0,-136)
    LINE(16,2)
    LINE(0,4)
    LINE(49,5)
    LINE(0,-2)
    LINE(8,0)
    LINE(7,2)
    LINE(0,80)
    LINE(9,2)
    LINE(0,11)
    LINE(-38,32)
    MOVE(38,-43)
    LINE(-61,43)
    LINE(-28,-8)
    LINE(80,-37)
    MOVE(9,2)
    LINE(24,-13)
    MOVE(-41,15)
    LINE(0,-85)
    MOVE(-7,1)
    LINE(0,82)
    LINE(7,2)
    MOVE(-56,-89)
    LINE(0,115)
    PLOT(7,40)
    LINE(-7,0)
    MOVE(23,31)
    LINE(49,0)
    MOVE(-17,0)
    LINE(17,21)
    MOVE(-49,6)
    LINE(24,-27)
    MOVE(25,57)
    LINE(-11,-17)
    LINE(-38,9)
    MOVE(9,12)
    CALL(5,$FIRE_STONE)
    MOVE(6,6)
    CALL(4,$FIRE_STONE)
    MOVE(-4,3)
    CALL(3,$FIRE_STONE)
    MOVE(8,-26)
    CALL(5,$FIRE_STONE)
    MOVE(8,7)
    CALL(4,$FIRE_STONE)
    MOVE(11,-10)
    CALL(4,$FIRE_STONE)
    LINE(5,-2)
    LINE(-6,2)
    MOVE(-16,-3)
    LINE(5,-2)
    FILL(0,0)
    MOVE(-13,11)
    LINE(6,-2)
    MOVE(-1,11)
    LINE(0,-3)
    LINE(4,2)
    MOVE(4,-9)
    LINE(7,0)
    AMOVE(231,119)
    LINE(24,0)
    SHADE(-3,10,$BKSLASHFILL)
    SHADE(-251,-83,$CLOSEDOTFILL)
    MOVE(-253,0)
    SHADE(0,0,$DOTFILL)
    SHADE(32,-16,$HATCHFILL)
    SHADE(72,0,$DOTFILL)
    SHADE(200,-40,$DOTFILL)
    SHADE(221,-67,$DOTFILL)
    SHADE(216,-8,$VLDOTFILL)
    SHADE(224,-48,$VLDOTFILL)
    SHADE(184,-24,$VLDOTFILL)
    SHADE(176,0,$DOTFILL)
    SHADE(187,-7,$VLDOTFILL)
    SHADE(181,-56,$VLDOTFILL)
    SHADE(212,5,$VLDOTFILL)
    SHADE(208,-8,$DOTFILL)
    SHADE(55,0,$INTERLEAVEFILL)
    MOVE(132,-53)
    CALL(6,$PAINTING)
    SHADE(-152,112,$DOTFILL)
    SHADE(-20,20,$LINEFILL)
END_DRAWING

DRAWING($BEDROOM,$FULLSCR)
    AMOVE(56,159)
    CALL(0,$BED_PILLAR)
    AMOVE(185,159)
    CALL(0,$BED_PILLAR)
    MOVE(11,0)
    LINE(0,21)
    LINE(-2,-1)
    MOVE(-10,-20)
    LINE(-117,0)
    LINE(0,24)
    LINE(-2,-3)
    MOVE(2,-2)
    LINE(10,3)
    LINE(8,-1)
    LINE(8,2)
    LINE(8,-2)
    LINE(8,3)
    LINE(8,-2)
    LINE(8,2)
    LINE(8,-3)
    LINE(8,2)
    LINE(8,-2)
    LINE(8,3)
    LINE(8,-3)
    LINE(8,3)
    LINE(8,-3)
    LINE(3,0)
    MOVE(-5,0)
    LINE(0,-8)
    MOVE(-14,0)
    LINE(0,8)
    MOVE(-16,0)
    LINE(0,-11)
    MOVE(-16,4)
    LINE(0,8)
    MOVE(-16,0)
    LINE(0,-12)
    MOVE(-16,3)
    LINE(0,8)
    MOVE(-16,0)
    LINE(0,-4)
    MOVE(-12,-3)
    LINE(0,7)
    MOVE(-6,0)
    LINE(18,11)
    LINE(80,0)
    LINE(22,-12)
    MOVE(-21,12)
    LINE(0,40)
    LINE(19,24)
    LINE(-118,0)
    LINE(18,-24)
    LINE(0,-40)
    MOVE(0,40)
    LINE(2,-3)
    LINE(1,-8)
    LINE(1,-1)
    LINE(31,0)
    LINE(1,8)
    LINE(0,6)
    LINE(-2,2)
    LINE(-32,0)
    LINE(-1,-4)
    MOVE(44,0)
    LINE(0,-8)
    LINE(3,-3)
    LINE(12,-1)
    LINE(16,0)
    LINE(2,2)
    LINE(2,8)
    LINE(1,5)
    LINE(-2,2)
    LINE(-19,0)
    LINE(-10,-2)
    LINE(-6,0)
    LINE(1,-3)
    LINE(-9,0)
    MOVE(48,4)
    LINE(-87,0)
    MOVE(-3,4)
    LINE(93,0)
    MOVE(-6,-2)
    LINE(-40,0)
    MOVE(-16,0)
    LINE(-24,0)
    MOVE(-21,58)
    LINE(8,2)
    LINE(11,-1)
    LINE(8,2)
    LINE(8,-1)
    LINE(8,2)
    LINE(8,-1)
    LINE(16,-2)
    LINE(16,2)
    LINE(8,-1)
    LINE(8,1)
    LINE(8,-1)
    LINE(8,1)
    LINE(7,-1)
    MOVE(-12,0)
    LINE(0,-8)
    MOVE(-14,2)
    LINE(0,7)
    MOVE(-24,-1)
    LINE(0,-10)
    MOVE(-16,0)
    LINE(0,10)
    MOVE(-22,0)
    LINE(0,-10)
    MOVE(-18,3)
    LINE(0,6)
    PLOT(57,24)
    LINE(-10,0)
    LINE(0,103)
    LINE(13,0)
    MOVE(-13,0)
    LINE(-47,23)
    MOVE(0,-143)
    LINE(47,16)
    PLOT(199,24)
    LINE(9,0)
    LINE(0,103)
    LINE(-11,0)
    MOVE(11,0)
    LINE(47,24)
    MOVE(0,-144)
    LINE(-48,17)
    PLOT(255,7)
    SHADE(-14,0,$LINEFILL)
    SHADE(-96,0,$LINEFILL)
    SHADE(-216,0,$LINEFILL)
    SHADE(-208,168,$LINEFILL)
    SHADE(-8,8,$VINTERLEAVEFILL)
    SHADE(-250,6,$VINTERLEAVEFILL)
    SHADE(-112,56,$HATCHFILL)
    SHADE(-112,33,$CLOSEDOTFILL)
    SHADE(-56,56,$DOTFILL)
    SHADE(-80,80,$DOTFILL)
    SHADE(-176,48,$DOTFILL)
    SHADE(-205,35,$DOTFILL)
    SHADE(-61,61,$CLOSEWAVEFILL)
    SHADE(-64,110,$SQDOTFILL)
    SHADE(-192,64,$CLOSEWAVEFILL)
    SHADE(-192,109,$SQDOTFILL)
END_DRAWING

DRAWING($CELLAR,$FULLSCR)
    PLOT(24,175)
    LINE(-24,-5)
    LINE(0,-55)
    LINE(24,4)
    LINE(0,56)
    LINE(26,-16)
    LINE(0,-48)
    LINE(-26,8)
    MOVE(26,-8)
    LINE(-17,-1)
    LINE(-33,5)
    MOVE(29,9)
    LINE(16,-6)
    LINE(0,40)
    LINE(-16,9)
    MOVE(13,-30)
    LINE(0,1)
    LINE(-2,3)
    LINE(-2,0)
    LINE(-2,-2)
    LINE(1,-4)
    LINE(2,0)
    MOVE(11,13)
    PLOT(50,148)
    LINE(45,-29)
    LINE(0,-72)
    LINE(-95,-40)
    MOVE(0,88)
    PLOT(0,95)
    LINE(11,-11)
    LINE(18,-6)
    LINE(14,0)
    LINE(12,9)
    LINE(8,19)
    LINE(0,33)
    LINE(16,5)
    LINE(10,12)
    LINE(-3,16)
    LINE(-7,3)
    PLOT(127,23)
    LINE(128,0)
    LINE(-40,24)
    LINE(-48,0)
    LINE(-40,-24)
    MOVE(40,24)
    LINE(0,4)
    LINE(48,0)
    LINE(0,-4)
    MOVE(-48,4)
    LINE(-3,0)
    LINE(0,5)
    LINE(53,0)
    MOVE(-53,0)
    LINE(-5,0)
    LINE(0,5)
    LINE(62,0)
    MOVE(-62,0)
    LINE(-4,0)
    LINE(0,5)
    LINE(69,0)
    LINE(-72,0)
    LINE(0,6)
    LINE(72,0)
    MOVE(-72,0)
    LINE(-4,0)
    LINE(0,5)
    LINE(80,0)
    LINE(-84,0)
    LINE(0,5)
    LINE(87,0)
    LINE(-90,0)
    LINE(-2,1)
    LINE(-1,1)
    LINE(96,0)
    LINE(-96,0)
    LINE(0,4)
    LINE(98,0)
    MOVE(-98,0)
    LINE(-3,2)
    LINE(102,0)
    MOVE(-102,0)
    LINE(0,5)
    LINE(105,0)
    MOVE(-105,0)
    LINE(-3,3)
    LINE(107,0)
    MOVE(-107,0)
    LINE(0,5)
    LINE(112,0)
    MOVE(-112,0)
    LINE(-2,2)
    LINE(-1,1)
    LINE(113,0)
    MOVE(-113,0)
    LINE(0,6)
    LINE(116,0)
    MOVE(-116,0)
    LINE(-3,3)
    LINE(124,0)
    MOVE(-124,0)
    LINE(0,5)
    LINE(121,0)
    MOVE(-121,0)
    LINE(-3,4)
    LINE(120,0)
    MOVE(-120,0)
    LINE(0,5)
    LINE(120,0)
    MOVE(-119,0)
    LINE(-5,4)
    LINE(128,0)
    MOVE(-128,0)
    LINE(0,6)
    LINE(121,0)
    LINE(0,-8)
    LINE(-4,-9)
    LINE(-2,-6)
    LINE(0,-2)
    LINE(-2,-8)
    LINE(-2,-8)
    LINE(-2,-2)
    LINE(0,-6)
    LINE(-2,-2)
    LINE(0,-4)
    LINE(-2,-2)
    LINE(0,-5)
    LINE(-4,-5)
    LINE(0,-6)
    LINE(-2,-5)
    LINE(-1,-5)
    LINE(-2,-5)
    PLOT(95,48)
    LINE(32,0)
    LINE(-2,-7)
    LINE(-14,-14)
    LINE(-16,-11)
    LINE(-12,-7)
    LINE(-9,-9)
    MOVE(53,48)
    LINE(-2,16)
    LINE(-3,11)
    LINE(-4,14)
    LINE(-5,18)
    LINE(0,11)
    LINE(0,2)
    LINE(-18,0)
    FILL(0,7)
    SHADE(1,-1,$CLOSEDASHFILL)
    SHADE(-5,-5,$CLOSEDOTFILL)
    SHADE(0,-80,$CLOSEDOTFILL)
    SHADE(-32,32,$DOTFILL)
    SHADE(-90,53,$DOTFILL)
    SHADE(-40,0,$LIGHTDOTFILL)
    SHADE(100,-90,$INTERLEAVEFILL)
END_DRAWING

// Picture subroutines...

DRAWING($PAINTING,$SUBROUTINE)
    MOVE(7,-39)
    LINE(32,0)
    LINE(0,31)
    LINE(-31,0)
    LINE(0,-31)
    LINE(0,24)
    LINE(4,-4)
    LINE(3,0)
    LINE(4,-2)
    LINE(-1,-3)
    LINE(-3,-4)
    LINE(4,-5)
    LINE(6,0)
    LINE(4,4)
    LINE(0,6)
    LINE(3,0)
    LINE(3,3)
    LINE(5,2)
    MOVE(4,11)
    LINE(0,-32)
    LINE(2,-2)
    LINE(-3,-3)
    LINE(-3,1)
    LINE(-33,0)
    LINE(-2,-2)
    LINE(-4,4)
    LINE(2,2)
    LINE(0,31)
    LINE(-2,2)
    LINE(4,4)
    LINE(2,-2)
    LINE(32,0)
    LINE(2,2)
    LINE(5,-5)
    LINE(-2,-2)
    SHADE(-9,-9,$HATCHFILL)
    FILL(-2,-2)
    MOVE(-2,0)
END_DRAWING

DRAWING($FRYING_PAN,$SUBROUTINE)
    MOVE(39,-75)
    LINE(9,5)
    LINE(5,10)
    LINE(2,21)
    LINE(-4,22)
    LINE(-4,10)
    LINE(-5,5)
    LINE(-26,2)
    LINE(-8,-11)
    LINE(-6,-20)
    LINE(2,-29)
    LINE(8,-15)
    LINE(5,-5)
    LINE(22,5)
    LINE(-8,7)
    LINE(-6,20)
    LINE(0,25)
    LINE(4,12)
    LINE(9,9)
    MOVE(-5,-74)
    LINE(0,-56)
    LINE(-8,0)
    LINE(0,55)
    LINE(3,3)
    LINE(5,-3)
    MOVE(-3,-8)
    LINE(0,-40)
END_DRAWING

DRAWING($FIRE_STONE,$SUBROUTINE)
    MOVE(0,5)
    LINE(4,0)
    LINE(3,-3)
    LINE(3,-1)
    LINE(3,-3)
    LINE(-2,-6)
    LINE(-5,-1)
    LINE(-5,1)
    LINE(-2,-2)
    LINE(-3,0)
    LINE(-4,3)
    LINE(0,3)
    LINE(-2,3)
    LINE(1,4)
    LINE(4,-1)
    LINE(1,2)
    LINE(2,2)
    LINE(3,-1)
END_DRAWING

DRAWING($BED_PILLAR,$SUBROUTINE)
    MOVE(5,0)
    LINE(5,0)
    LINE(3,-3)
    LINE(-2,-2)
    LINE(0,-31)
    LINE(2,-3)
    LINE(0,-8)
    LINE(-2,-4)
    LINE(0,-24)
    LINE(2,-3)
    LINE(0,-16)
    LINE(-2,-3)
    LINE(0,-27)
    LINE(-4,-4)
    LINE(-3,3)
    LINE(0,28)
    LINE(-2,3)
    LINE(0,16)
    LINE(2,3)
    LINE(0,25)
    LINE(-2,2)
    LINE(0,8)
    LINE(2,3)
    LINE(0,0)
    LINE(0,32)
    LINE(-2,2)
    LINE(3,3)
    MOVE(-2,-40)
    LINE(5,0)
    MOVE(0,5)
    LINE(-4,0)
    MOVE(-2,-12)
    LINE(11,0)
    MOVE(-2,-3)
    LINE(-7,0)
    MOVE(0,-25)
    LINE(7,0)
    MOVE(2,-4)
    LINE(-11,0)
    MOVE(0,-15)
    LINE(11,0)
    MOVE(-2,-3)
    LINE(-7,0)
    MOVE(0,90)
    LINE(7,0)
    MOVE(-4,-28)
    LINE(4,0)
    MOVE(-7,-90)
    LINE(-3,3)
    LINE(0,-22)
    LINE(5,-8)
    LINE(-2,-2)
    LINE(4,-5)
    LINE(3,4)
    LINE(-2,2)
    LINE(4,9)
    LINE(-11,0)
END_DRAWING

DRAWING($DOOR,$SUBROUTINE)
    LINE(0,-144)
    LINE(80,0)
    LINE(0,144)
    LINE(-80,0)
    MOVE(8,-8)
    LINE(0,-56)
    LINE(24,0)
    LINE(0,56)
    LINE(-24,0)
    MOVE(64,0)
    LINE(-24,0)
    LINE(0,-56)
    LINE(24,0)
    LINE(0,56)
    MOVE(0,-72)
    LINE(0,-56)
    LINE(-24,0)
    LINE(0,56)
    LINE(24,0)
    MOVE(-40,0)
    LINE(-24,0)
    LINE(0,-56)
    LINE(24,0)
    LINE(0,56)
    SHADE(40,5,$CLOSEDOTFILL)
    SHADE(32,-8,$VLINEFILL)
    SHADE(-8,-8,$VLINEFILL)
    SHADE(32,24,$VLINEFILL)
    SHADE(-8,24,$VLINEFILL)
END_DRAWING

$$EXTERN

// +------------------+
// | External Section |
// +------------------+

// Here is an example of implementation of the debugger using C language (this
// part is just for debuging purposes, and may be removed without any
// consequences to the normal flow of the game). For more information, see
// Part 4 of the Quill User Manual.

    char buf[50];                      // Buffer for sprintf
    int i,n,v;                         // Auxilary vars

    int getint(void)                   // Returns a number from the keyboard
      {
        $GETLINE$();                   // Get the input line
        return atoi($BUFFER$);         // Convert input buffer to an integer
      }

    switch($ARG$)                      // What is the parameter after EXTERN
      {
        case 0:                        // EXTERN(0): SHOW FLAGS
          for(i=0;i<=$NFLAG$;i++)
            {
              sprintf(buf,"F%d=%d ",i,$FLAGS$[i]);
              $PRINT$(buf);
            }
          $PRINT$("\n");
          break;
        case 1:                        // EXTERN(1): SHOW OBJECTS
          for(i=0;i<=$NOBJ$;i++)
            {
              sprintf(buf,"O%d=%d ",i,$OBJECTS$[i].L);
              $PRINT$(buf);
            }
          $PRINT$("\n");
          break;
        case 2:                        // EXTERN(2): MODIFY FLAGS
          $PRINT$("Which flag? ");
          n=getint();
          $PRINT$("Value? "); 
          v=getint();
          if(n<=$NFLAG$) $FLAGS$[n]=v;
          return $DESC;
        case 3:                        // EXTERN(3): MODIFY OBJECTS
          $PRINT$("Which object? ");
          n=getint();
          $PRINT$("New location? ");
          v=getint();
          if(n<=$NOBJ$) $OBJECTS$[n].L=v;
          return $DESC;
      }

// End of the implementation of the debugger...

$$END
